.\" $Header: trace.3,v 2.0 89/12/24 00:56:31 eric Exp $
.TH TRACE 3
.SH NAME
TRACE, TRACEF, traceset \- trace package
.SH SYNOPSIS
#include <useful.h>
.PP
BOOL TRACEF(flag, level)
.br
int flag;
.br
int level;
.PP
TRACE(flag, level, (\fIprintf arguments\fP));
.PP
void traceset(tracestring)
.br
char *tracestring;
.SH DESCRIPTION
The
.I traceset
routine and the
.I TRACE
and
.I TRACEF
macros implement a simple trace flag package.
A large number of trace flags
(200 default)
can each be set to a trace level
varying from zero
(no tracing for this flag)
to 255
(full tracing).
.PP
The
.I TRACEF
macro tests whether the specified flag is set to at least the indicated level.
For example:
.PP
	if (TRACEF(24, 3))
.PP
tests flag 24; if it is set to 3 or higher,
the
.B if
statement succeeds.
.PP
The
.I TRACE
macro incorporates a
.IR printf (3)
statement.
For example, the code:
.PP
	TRACE(24, 3, ("xyzzy = %d\n", xyzzy));
.PP
Prints the ``xyzzy'' variable
when trace flag 24 is set to level 3 or higher.
The extra set of parentheses is important.
.PP
Flags can be adjusted using the
.I traceset
routine.
This parses the trace string, setting indicated flags as it goes.
The string is a comma-separated list of trace settings.
Each setting has the syntax:
.PP
	flag[\-flag][.level]
.PP
If the level is omitted, one is assumed.
If only one flag is indicated,
it is set individually.
If a range of flags is given,
all flags inclusively between the two values are set.
For example:
.PP
	20\-29.2
.PP
sets the ten flags numbered between 20 and 29 to level 2.
.PP
Flag names can be symbolic.
Symbolic names are looked up in the file
``<searchpath>/lib/traceflags'',
where
<searchpath>
is the default search path used by
.IR openpath (3).
This file is a series of lines, each containing a flag name,
white space,
and the flag value.
Blank lines
and lines beginning with `#' are ignored.
Case is ignored in flag names.
.SH SEE ALSO
openpath(3),
parseargs(3)
.SH AUTHOR
Eric Allman, University of California, Berkeley
